<!-- Generated by documentation.js. Update this documentation by updating the source code. -->

### Table of Contents

-   [Matrix](#matrix)
    -   [constructor](#constructor)
    -   [isCommutative](#iscommutative)
    -   [add](#add)
    -   [product](#product)
    -   [dot](#dot)

## Matrix

[src/modules/matrix.js:8-91](https://github.com/Gmousse/dataframe-js/blob/8a9b7e074e26a88e1026451b85d965049ba49d6b/src/modules/matrix.js#L8-L91 "Source code on GitHub")

Matrix module for DataFrame, providing basic mathematical matrix computations.

**Parameters**

-   `df`  

### constructor

[src/modules/matrix.js:13-16](https://github.com/Gmousse/dataframe-js/blob/8a9b7e074e26a88e1026451b85d965049ba49d6b/src/modules/matrix.js#L13-L16 "Source code on GitHub")

Start the Matrix module.

**Parameters**

-   `df` **DataFrame** An instance of DataFrame.

### isCommutative

[src/modules/matrix.js:26-29](https://github.com/Gmousse/dataframe-js/blob/8a9b7e074e26a88e1026451b85d965049ba49d6b/src/modules/matrix.js#L26-L29 "Source code on GitHub")

Check if two DataFrames are commutative, if both have the same dimensions.

**Parameters**

-   `df` **DataFrame** The second DataFrame to check.
-   `reverse` **[Boolean](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** Revert the second DataFrame before the comparison. (optional, default `false`)

**Examples**

```javascript
df.matrix.isCommutative(df2)
```

Returns **[Boolean](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** True if they are commutative, else false.

### add

[src/modules/matrix.js:38-51](https://github.com/Gmousse/dataframe-js/blob/8a9b7e074e26a88e1026451b85d965049ba49d6b/src/modules/matrix.js#L38-L51 "Source code on GitHub")

Provide an elements pairwise addition of two DataFrames having the same dimensions.

**Parameters**

-   `df` **DataFrame** The second DataFrame to add.

**Examples**

```javascript
df.matrix.add(df2)
```

Returns **DataFrame** A new DataFrame resulting to the addition two DataFrames.

### product

[src/modules/matrix.js:60-63](https://github.com/Gmousse/dataframe-js/blob/8a9b7e074e26a88e1026451b85d965049ba49d6b/src/modules/matrix.js#L60-L63 "Source code on GitHub")

Provide a scalar product between a number and a DataFrame.

**Parameters**

-   `number` **[Number](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Number)** The number to multiply.

**Examples**

```javascript
df.matrix.product(6)
```

Returns **DataFrame** A new DataFrame resulting to the scalar product.

### dot

[src/modules/matrix.js:72-90](https://github.com/Gmousse/dataframe-js/blob/8a9b7e074e26a88e1026451b85d965049ba49d6b/src/modules/matrix.js#L72-L90 "Source code on GitHub")

Multiply one DataFrame n x p and a second p x n.

**Parameters**

-   `df` **DataFrame** The second DataFrame to multiply.

**Examples**

```javascript
df.matrix.dot(df)
```

Returns **DataFrame** A new n x n DataFrame resulting to the product of two DataFrame.
