<!-- Generated by documentation.js. Update this documentation by updating the source code. -->

### Table of Contents

-   [SQL](#sql)
    -   [constructor](#constructor)
    -   [register](#register)
    -   [request](#request)
    -   [dropTables](#droptables)
    -   [dropTable](#droptable)
    -   [renameTable](#renametable)
    -   [listTables](#listtables)
    -   [registerTable](#registertable)

## SQL

[src/modules/sql/index.js:8-105](https://github.com/Gmousse/dataframe-js/blob/8a9b7e074e26a88e1026451b85d965049ba49d6b/src/modules/sql/index.js#L8-L105 "Source code on GitHub")

SQL module for DataFrame, providing SQL-like syntax for data exploration in DataFrames.

**Parameters**

-   `df`  

### constructor

[src/modules/sql/index.js:88-91](https://github.com/Gmousse/dataframe-js/blob/8a9b7e074e26a88e1026451b85d965049ba49d6b/src/modules/sql/index.js#L88-L91 "Source code on GitHub")

Start the SQL module.

**Parameters**

-   `df` **DataFrame** An instance of DataFrame.

### register

[src/modules/sql/index.js:100-103](https://github.com/Gmousse/dataframe-js/blob/8a9b7e074e26a88e1026451b85d965049ba49d6b/src/modules/sql/index.js#L100-L103 "Source code on GitHub")

Register the DataFrame as temporary table.

**Parameters**

-   `tableName` **[String](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** The name of the table.
-   `overwrite` **[Boolean](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** Overwrite if the table already exists. (optional, default `false`)

**Examples**

```javascript
df.sql.register('tmp');
```

### request

[src/modules/sql/index.js:17-20](https://github.com/Gmousse/dataframe-js/blob/8a9b7e074e26a88e1026451b85d965049ba49d6b/src/modules/sql/index.js#L17-L20 "Source code on GitHub")

Request on a SQL query.

**Parameters**

-   `query` **[String](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** A SQL query to request.

**Examples**

```javascript
DataFrame.request('SELECT * FROM tmp');
```

Returns **any** The result of the query.

### dropTables

[src/modules/sql/index.js:27-29](https://github.com/Gmousse/dataframe-js/blob/8a9b7e074e26a88e1026451b85d965049ba49d6b/src/modules/sql/index.js#L27-L29 "Source code on GitHub")

Drop or remove all registered tables.

**Examples**

```javascript
DataFrame.dropTables();
```

### dropTable

[src/modules/sql/index.js:37-39](https://github.com/Gmousse/dataframe-js/blob/8a9b7e074e26a88e1026451b85d965049ba49d6b/src/modules/sql/index.js#L37-L39 "Source code on GitHub")

Drop or remove a registered table.

**Parameters**

-   `tableName` **[String](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** The registered table to drop.

**Examples**

```javascript
DataFrame.dropTable('tmp1');
```

### renameTable

[src/modules/sql/index.js:49-52](https://github.com/Gmousse/dataframe-js/blob/8a9b7e074e26a88e1026451b85d965049ba49d6b/src/modules/sql/index.js#L49-L52 "Source code on GitHub")

Rename a registered table.

**Parameters**

-   `tableName` **[String](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** The registered table to rename.
-   `replacement` **[String](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** The new table name.
-   `overwrite` **[Boolean](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** Overwrite if the table already exists. (optional, default `false`)

**Examples**

```javascript
DataFrame.renameTable('tmp1', 'notTmp1');
```

### listTables

[src/modules/sql/index.js:60-62](https://github.com/Gmousse/dataframe-js/blob/8a9b7e074e26a88e1026451b85d965049ba49d6b/src/modules/sql/index.js#L60-L62 "Source code on GitHub")

List all registered tables.

**Examples**

```javascript
DataFrame.listTables();
```

Returns **[Array](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Array)** A list of the registered tables.

### registerTable

[src/modules/sql/index.js:72-82](https://github.com/Gmousse/dataframe-js/blob/8a9b7e074e26a88e1026451b85d965049ba49d6b/src/modules/sql/index.js#L72-L82 "Source code on GitHub")

Register a DataFrame as a temporary table.

**Parameters**

-   `df` **DataFrame** The DataFrame to register.
-   `tableName` **[String](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** The temporary table name.
-   `overwrite` **[Boolean](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** Overwrite if the table already exists. (optional, default `false`)

**Examples**

```javascript
DataFrame.registerTable('tmp', df);
```
