<!-- Generated by documentation.js. Update this documentation by updating the source code. -->

### Table of Contents

-   [Stat](#stat)
    -   [constructor](#constructor)
    -   [sum](#sum)
    -   [max](#max)
    -   [min](#min)
    -   [mean](#mean)
    -   [average](#average)
    -   [var](#var)
    -   [sd](#sd)
    -   [stats](#stats)

## Stat

[src/modules/stat.js:6-133](https://github.com/Gmousse/dataframe-js/blob/8a9b7e074e26a88e1026451b85d965049ba49d6b/src/modules/stat.js#L6-L133 "Source code on GitHub")

Stat module for DataFrame, providing basic statistical metrics for numeric columns.

**Parameters**

-   `df`  

### constructor

[src/modules/stat.js:11-14](https://github.com/Gmousse/dataframe-js/blob/8a9b7e074e26a88e1026451b85d965049ba49d6b/src/modules/stat.js#L11-L14 "Source code on GitHub")

Start the Stat module.

**Parameters**

-   `df` **DataFrame** An instance of DataFrame.

### sum

[src/modules/stat.js:28-32](https://github.com/Gmousse/dataframe-js/blob/8a9b7e074e26a88e1026451b85d965049ba49d6b/src/modules/stat.js#L28-L32 "Source code on GitHub")

Compute the sum of a numeric column.

**Parameters**

-   `columnName` **[String](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** The column to evaluate, containing Numbers.

**Examples**

```javascript
df.stat.sum('column1')
```

Returns **[Number](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Number)** The sum of the column.

### max

[src/modules/stat.js:41-45](https://github.com/Gmousse/dataframe-js/blob/8a9b7e074e26a88e1026451b85d965049ba49d6b/src/modules/stat.js#L41-L45 "Source code on GitHub")

Compute the maximal value into a numeric column.

**Parameters**

-   `columnName` **[String](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** The column to evaluate, containing Numbers.

**Examples**

```javascript
df.stat.max('column1')
```

Returns **[Number](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Number)** The maximal value into the column.

### min

[src/modules/stat.js:54-58](https://github.com/Gmousse/dataframe-js/blob/8a9b7e074e26a88e1026451b85d965049ba49d6b/src/modules/stat.js#L54-L58 "Source code on GitHub")

Compute the minimal value into a numeric column.

**Parameters**

-   `columnName` **[String](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** The column to evaluate, containing Numbers.

**Examples**

```javascript
df.stat.min('column1')
```

Returns **[Number](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Number)** The minimal value into the column.

### mean

[src/modules/stat.js:67-72](https://github.com/Gmousse/dataframe-js/blob/8a9b7e074e26a88e1026451b85d965049ba49d6b/src/modules/stat.js#L67-L72 "Source code on GitHub")

Compute the mean value into a numeric column.

**Parameters**

-   `columnName` **[String](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** The column to evaluate,isNumber(n.get(columnName)) ? p + Number( containing Numbers.

**Examples**

```javascript
df.stat.mean('column1')
```

Returns **[Number](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Number)** The mean value into the column.

### average

[src/modules/stat.js:82-84](https://github.com/Gmousse/dataframe-js/blob/8a9b7e074e26a88e1026451b85d965049ba49d6b/src/modules/stat.js#L82-L84 "Source code on GitHub")

Compute the mean value into a numeric column.
Alias from mean.

**Parameters**

-   `columnName` **[String](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** The column to evaluate, containing Numbers.

**Examples**

```javascript
df.stat.min('column1')
```

Returns **[Number](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Number)** The mean value into the column.

### var

[src/modules/stat.js:94-100](https://github.com/Gmousse/dataframe-js/blob/8a9b7e074e26a88e1026451b85d965049ba49d6b/src/modules/stat.js#L94-L100 "Source code on GitHub")

Compute the variance into a numeric column.

**Parameters**

-   `columnName` **[String](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** The column to evaluate, containing Numbers.
-   `population` **[Boolean](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** Population mode. If true, provide the population variance, not the sample one. (optional, default `false`)

**Examples**

```javascript
df.stat.var('column1')
```

Returns **[Number](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Number)** The variance into the column.

### sd

[src/modules/stat.js:110-112](https://github.com/Gmousse/dataframe-js/blob/8a9b7e074e26a88e1026451b85d965049ba49d6b/src/modules/stat.js#L110-L112 "Source code on GitHub")

Compute the standard deviation into a numeric column.

**Parameters**

-   `columnName` **[String](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** The column to evaluate, containing Numbers.
-   `population` **[Boolean](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Boolean)** Population mode. If true, provide the population standard deviation, not the sample one. (optional, default `false`)

**Examples**

```javascript
df.stat.sd('column1')
```

Returns **[Number](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Number)** The standard deviation into the column.

### stats

[src/modules/stat.js:121-132](https://github.com/Gmousse/dataframe-js/blob/8a9b7e074e26a88e1026451b85d965049ba49d6b/src/modules/stat.js#L121-L132 "Source code on GitHub")

Compute all the stats available with the Stat module on a numeric column.

**Parameters**

-   `columnName` **[String](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** The column to evaluate, containing Numbers.

**Examples**

```javascript
df.stat.stats('column1')
```

Returns **[Object](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/Object)** An dictionnary containing all statistical metrics available.
